["Santa Is Watching" (aka Santa_IW)](https://gitlab.com/SRG_gitlab/santa-is-watching) is a network monitoring tool with an 
emphasis on ZFS and network attached storage in a homelab environment. Based upon configuration files describing your 
system, Santa_IW periodically cycles through a suite of
tests on your computers, disks, and network hardware. Santa_IW runs on a single Linux computer which needs ssh keys
to run diagnostic commands on other computers in your system. Santa_IW includes a network discovery tool which takes a
list of start and stop network addresses to scan and tries to determine what tests are appropriate for each node it
finds. Any computer which responds to a network ping becomes a candidate for ping testing. If Santa_IW can make an 
ssh connection to the node, it will:

* look at temperature and other data reported by lm-sensors
* look for drives listed in /etc/fstab and monitor each for disk free space
* look for drives supported by smartctl and report SMART status on them
* look for zfs pools and check each for status and free space
* look for zfs volumes which seem to be getting frequent snapshots (or are listed in pyznap's config file) and monitor
  the age of the last snapshot
* look for failed services reported by systemctl --failed

Santa_IW is written entirely in Python (3.11 or later) and its configuration files are all editable json. It ships with 20+ built in test types
and can load additional user written tests or plugins from user directories. An example plugin is provided to use a
Philips Hue color changing light bulb to provide a GREEN/YELLOW/RED status light.

A web based interface lets the user navigate up and down the hierarchy of node groups, nodes and tests to see various
levels of detail. Tests can record numeric data where appropriate. Running averages are displayed and values over time
can be graphed or extracted for offline processing.

----

Santa_IW is hosted on [GitLab](https://gitlab.com/SRG_gitlab/santa-is-watching/-/wikis/home) and has been developed and tested on a Linux platform. It has been run installed and run on RHEL, Fedora, Ubuntu
and Debian platforms (including Raspberry Pi 3). It is written in pure Python, but calls out to many Linux/Posix
command line utilities. It is plausible that it might someday work on other Posix compliant platforms (macOS or BSD),
but that is out of scope for the current effort. [For windows support...](https://en.wikipedia.org/wiki/Somebody_else%27s_problem)

Santa_IW is intended for homelab use on an internal network. It does not yet have any robust authentication system and
should not be exposed on the open internet.

# 🚧 PRE-BETA RELEASE 🚧

If you are reading this, you are a little bit early to the party, but feel free to look
around. Installation and operating instructions are on the [wiki](https://gitlab.com/SRG_gitlab/santa-is-watching/-/wikis/home)
if you are interested in a test drive. The [Roadmap page]
(https://gitlab.com/SRG_gitlab/santa-is-watching/-/wikis/Roadmap) describes some of the work pending before I start 
inviting people to beta test. The code as-is works well, but many of the pending changes planned will invalidate the 
documentation. Expecting new users to read the manual once is a big ask these days, so asking them to do it all 
again after major changes would be too much.